<?php

require_once 'ajaxSetup.php';
$pageTarget = $folder . 'gigs.ajax.php';

switch ($_POST['action']) {
	case 'load':
		$v = new venue();
		$g = new gig();
		$p = new performance();
		$g->search("date >= CURDATE()", 'date');
		$v->search('deleted = 0', 'name');
		?>
			<div class="clickable" id="gig-add-trigger">
				<img class="icon" src="<?php echo $folder; ?>images/add.png" /> Add a new gig
			</div>
			<div id="gig-add-form" style="display: none;">
				<form id="new-gig" class="new-item" method="post" action="<?php echo $pageTarget; ?>">
					<table>
						<tbody>
							<tr><td colspan="2">
								<h3 class="no-margin">Gig Information</h3>
								<div class="instructions">A "gig" is unique to a date at a venue.</div>
							</td></tr>
							<tr>
								<td><label for="new-venue">Venue:</label></td>
								<td>
									<?php if ( $v->_count ) : ?>
										<select name="venueID" id="new-venue">
											<option value="-1">Select a venue</option>
											<?php while ( $v->fetch() ) : ?>
												<option value="<?php echo $v->id ?>"><?php echo $v->name . ' - ' . $v->getCity() ?></option>
											<?php endwhile; ?>
										</select>
									<?php else : ?>
											No venues found.  You'll need to <span class="link" id="add-venue">add one</span>.
									<?php endif; ?>
								</td>
							</tr>
							<tr>
								<td><label for="new-date">Date:</label></td>
								<td><input type="text" class="date wide" name="date" id="new-date" /></td>
							</tr>
							<tr>
								<td><label for="new-eventName">Event Name:</label></td>
								<td><input type="text" class="eventName wide" name="eventName" id="new-eventName" /></td>
							</tr>
							<tr><td colspan="2">
								<div class="instructions">Some artists perform under several names.  Ignore this field if you don't need <br />to specify what this event is called or what band name you are playing under.</div>
							</td></tr>

							<tr><td colspan="2">
								Description/Other notes:<br />
								<textarea class="notes" name="notes" rows="5" cols="52"></textarea>
							</td></tr>
							<tr><td colspan="2">
								<h3 class="no-margin">Performances</h3>
								<div class="instructions">You can add as many performances as<br />you are giving at a venue on the given date.</div>
							</td></tr>
							<tr><td colspan="2">
								<?php pForm(1, true, false) ?>
							</td></tr>
							<tr><td colspan="2">
								<div class="clickable add-performance"><img class="icon" src="<?php echo $folder; ?>images/add.png" /> Add another performance</div>
							</td></tr>

						</tbody>
					</table>
					<div>
						<input type="submit" name="" value="Add Gig" />
						<input type="reset" name="" value="Cancel" id="new-gig-reset" />
						<input type="hidden" name="action" value="add" />
						<input type="hidden" name="nonce" value="<?php echo $_POST['nonce']; ?>" />
					</div>
				</form>
			</div>
			
			<table id="gig-list" class="gigs widefat">
				<thead>
					<tr>
						<th style="text-align: center;" scope="col">ID</th>
						<th scope="col">Event Name</th>
						<th scope="col">Venue</th>
						<th scope="col">City</th>
						<th scope="col">Date</th>
						<th scope="col">Time</th>
						<th style="text-align: center" scope="col">Actions</th>
					</tr>
				</thead>
				<tbody>
					<?php while ( $g->fetch() ) : $v = $g->getVenue(); $p = $g->getPerformances(); $post = get_post($g->postID);?>
						<tr id="gig-<?php echo $g->id; ?>" class="gig gig-<?php echo $g->id; ?> <?php echo ++$count % 2 ? "alternate" : "";?>">
							<th style="text-align: center;" scope="row"><?php echo $g->id; ?></th>
							<td class="eventName"><?php echo $g->eventName; ?></td>
							<td class="venue"><?php echo $v->name; ?></td>
							<td class="city"><?php echo $v->city . (!empty($v->state) ? ', ' . $v->state :  '') ?></td>
							<td class="date"><?php echo $g->date ?></td>
							<td class="time">
								<?php if ( $p ) : while ( $p->fetch() ) : ?>
									<span class="time"><?php echo date("g:ia", strtotime($p->time)) ?></span>
								<?php endwhile; endif; ?>
							</td>
							<td class="actions" style="text-align: center; position: relative;">
								<div style="position: relative">
									<a target="_blank" class="guid" href="<?php echo $g->getPermalink(); ?>"><img alt="View Gig" title="View Gig" class="clickable view" src="<?php echo $folder; ?>images/page_white_magnify.png" /></a>
									<img alt="Edit" title="Edit" class="clickable edit" src="<?php echo $folder; ?>images/page_white_edit.png" />
									<?php if ( $v ) : ?>
										<a target="_blank" href="<?php echo $v->getMapLink(); ?>"><img alt="Map" title="Map" class="clickable map" src="<?php echo $folder; ?>images/world.png" /></a>
									<?php endif ?>
									<img alt="Delete" title="Delete" class="clickable delete" src="<?php echo $folder; ?>images/delete.png" />
								</div>
							</td>
						</tr>
						<tr id="gig-panel-<?php echo $g->id; ?>" class="gig gig-<?php echo $g->id; ?> panel <?php echo $count % 2 ? "alternate" : "";?>">
							<td style="background-color: white"></td>
							<td class="panel" colspan="5"></td>
						</tr>
					<?php endwhile; ?>
				</tbody>
			</table>
				
			<script type="text/javascript">
			
				(function($){
					$("#add-venue").click(function(){
						gigs_page_load("venues", "new=1");
					});
					
					$("#gig-add-trigger").click(function(){
						$("#gig-add-form:hidden").slideDown(300, function(){
							$("#new-name").focus();
						});
					});
					
					$("#new-gig-reset").click(function(){
						$("#gig-add-form table.performance[id!=performance-c1]").parents("tr").remove();
						$("#gig-add-form").slideUp(300);
					});
					
					$("#new-date").calendar({dateFormat:"YMD-"});
					
					
					$("#new-gig").ajaxForm({
						dataType: "json",
						success:function(json){
							gigs = $("table#gig-list tbody tr:not(.panel) td.date");
							inserted = false;
							for ( i = 0; i < gigs.length; i++ ) {
								if ( json.gig.date < gigs.eq(i).html() ) {
									g = gigs.eq(i);
									$.post(pageTarget, {
										nonce:nonce,
										action:'getRow',
										id:json.gig.id
									}, function(rsp){
										g.parents("tr").before(rsp);
										resetTableColors("table#gig-list");
										setupEvents();
									});
									inserted = true;
									break;
								}
							}
							if ( !inserted ) {
								$.post(pageTarget, {
									nonce:nonce,
									action:'getRow',
									id:json.gig.id
								}, function(rsp){
									$("table#gig-list tbody").append(rsp);
									resetTableColors("table#gig-list");
									setupEvents();
								});
							}
							$("#new-gig-reset").click();
						}

					});
					
					setupPerformanceRemoval = function() {
						$("div.delete-performance img").unbind("click");
						$("div.delete-performance img").click(function(){
							id = $(this).parents("tr").eq(0).find("input.performanceID").val();
							if ( id == "" ) {
								$(this).parents("tr").eq(1).remove();
							} else {
								if ( confirm("Are you sure you want to remove this performance?") ) {
									$(this).parents("form").children(".extra-inputs").append('<input type="hidden" name="delete[]" value="' + id + '" />');
									$(this).parents("tr").eq(1).remove();
								}
							}
						});
					}
					
					setupPerformances = function() {
						$(".add-performance").unbind("click");
						$(".add-performance").click(function(){
							td = $(this).parents("tr").eq(0).before("<tr><td colspan='2'><div class='loading'><img src='<?php echo $folder; ?>images/ajax-loader.gif' alt='' /></div></td></tr>").prev().children("td").load(pageTarget,{
								nonce:nonce,
								action:"performance-form",
								count:$(this).parents("table").eq(0).find("table.performance").length + 1
							}, setupPerformanceRemoval);
						});
						setupPerformanceRemoval();

					}
					
					setupEvents = function() {
						$("img.delete").unbind("click");
						$("img.delete").click(function(){
							id = $(this).parents("tr").attr("id").split("-")[1];
							$.post(pageTarget, {
								nonce:nonce,
								action:'delete',
								id:id
							});
							$(this).parents("tr").next().remove();
							$(this).parents("tr").remove();
							resetTableColors("table#gig-list");
						});
						
						$("img.edit").unbind("click");
						$("img.edit").click(function(){
							row = $(this).parents("tr");
							id = row.attr("id").split("-")[1];
							row.next().children("td.panel").load(pageTarget, {
								nonce:nonce,
								action:"edit",
								id:id
							}, function(){
								row.next().css("display", "table-row");
							});
						});
						
						setupPerformances();
					}
					
					setupEvents();

				}(jQuery));
				
			
			
			</script>
			
			<div class="todo">
				<h3>Todo</h3>
				<ul>
					<li>gig setlist (0.3)</li>
					<li>custom show data (0.4)</li>
					<li>User submitted content (0.5)</li>
				</ul>
			</div>
		<?php
		break;
	case 'add':
		$g = new gig();
		//$p = new performance();
		
		$g->venueID = $_POST['venueID'];
		$g->date = $_POST['date'];
		$g->notes = $_POST['notes'];
		$g->eventName = $_POST['eventName'];
		
		if ( $g->save() ) {
			if ( isset($_POST['performanceID']) ) {
				foreach ( $_POST['performanceID'] as $key => $pid ) {
					$p = new performance((empty($pid) ? null : $pid));
					$p->gigID = $g->id;
					$p->link = $_POST['link'][$key];
					$p->shortNotes = $_POST['shortNotes'][$key];
					$p->ages = (empty($_POST['ages-custom'][$key]) ? $_POST['ages'][$key] : $_POST['ages-custom'][$key]);
					$p->time = date("H:i:s", strtotime($_POST['hour'][$key] . ':' . $_POST['minute'][$key] . ' ' . $_POST['meridiem'][$key]));
					$p->save();
				}
			}
			
			echo '{success:true, gig:' . $g->toJSON() . '}';
		} else {
			echo '{success:false}';
		}
		break;
	case 'getRow':
		$g = new gig($_POST['id']);
		$v = $g->getVenue();
		$p = $g->getPerformances();
		$post = get_post($g->postID);
		?>
			<tr id="gig-<?php echo $g->id; ?>" class="gig gig-<?php echo $g->id; ?> <?php echo ++$count % 2 ? "alternate" : "";?>">
				<th style="text-align: center;" scope="row"><?php echo $g->id; ?></th>
				<td class="eventName"><?php echo $g->eventName; ?></td>
				<td class="venue"><?php echo $v->name; ?></td>
				<td class="city"><?php echo $v->city . (!empty($v->state) ? ', ' . $v->state :  '') ?></td>
				<td class="date"><?php echo $g->date ?></td>
				<td class="time">
					<?php if ( $p ) : while ( $p->fetch() ) : ?>
						<span class="time"><?php echo date("g:ia", strtotime($p->time)) ?></span>
					<?php endwhile; endif; ?>
				</td>
				<td class="actions" style="text-align: center; position: relative;">
					<div style="position: relative">
						<a target="_blank" class="guid" href="<?php echo $g->getPermalink(); ?>"><img alt="View Gig" title="View Gig" class="clickable view" src="<?php echo $folder; ?>images/page_white_magnify.png" /></a>
						<img alt="Edit" title="Edit" class="clickable edit" src="<?php echo $folder; ?>images/page_white_edit.png" />
						<?php if ( $v ) : ?>
							<a target="_blank" href="<?php echo $v->getMapLink(); ?>"><img alt="Map" title="Map" class="clickable map" src="<?php echo $folder; ?>images/world.png" /></a>
						<?php endif ?>
						<img alt="Delete" title="Delete" class="clickable delete" src="<?php echo $folder; ?>images/delete.png" />
					</div>
				</td>
			</tr>
			<tr id="gig-panel-<?php echo $g->id; ?>" class="gig gig-<?php echo $g->id; ?> panel <?php echo $count % 2 ? "alternate" : "";?>">
				<td style="background-color: white"></td>
				<td class="panel" colspan="5"></td>
			</tr>
		<?php
		break;
	
	case 'delete':
		$g = new gig($_POST['id']);
		$g->delete();
		break;
	case 'edit':
		$g = new gig($_POST['id']);
		$p = $g->getPerformances();
		$v = $g->getVenue();
		?>
			<form id="edit-gig-<?php echo $g->id ?>" class="edit-item" method="post" action="<?php echo $pageTarget; ?>">
				<table>
					<tbody>
						<tr><td colspan="2">
							<h3 class="no-margin">Gig Information</h3>
							<div class="instructions">A "gig" is unique to a date at a venue.</div>
						</td></tr>
						<tr>
							<td>Venue:</td>
							<td>
								<?php echo $v->name . ' - ' . $v->getCity() ?>
							</td>
						</tr>
						<tr>
							<td><label for="edit-date-<?php echo $g->id ?>">Date:</label></td>
							<td><input type="text" class="date wide" name="date" id="edit-date-<?php echo $g->id ?>" value="<?php echo $g->date ?>" /></td>
						</tr>
						<tr>
							<td><label for="edit-eventName-<?php echo $g->id ?>">Event Name:</label></td>
							<td><input type="text" class="eventName wide" name="eventName" id="edit-eventName-<?php echo $g->id ?>" value="<?php echo $g->eventName ?>" /></td>
						</tr>
						<tr><td colspan="2">
							<div class="instructions">Some artists perform under several names.  Ignore this field if you don't need <br />to specify what this event is called or what band name you are playing under.</div>
						</td></tr>

						<tr><td colspan="2">
							Description/Other notes:<br />
							<textarea class="notes" name="notes" rows="5" cols="52"><?php echo $g->notes ?></textarea>
						</td></tr>
						<tr><td colspan="2">
							<h3 class="no-margin">Performances</h3>
							<div class="instructions">You can add as many performances as<br />you are giving at a venue on the given date.</div>
						</td></tr>
						<?php while ( $p->fetch() ) : ?>
							<tr><td colspan="2">
								<?php pForm($p->id, false) ?>
							</td></tr>
						<?php endwhile ?>
						</td></tr>
						<tr><td colspan="2">
							<div class="clickable add-performance"><img class="icon" src="<?php echo $folder; ?>images/add.png" /> Add another performance</div>
						</td></tr>

					</tbody>
				</table>
				<div class="extra-inputs">
					<input type="submit" name="" value="Save Gig" />
					<input type="reset" name="" value="Cancel" id="edit-gig-reset-<?php echo $g->id ?>" />
					<input type="hidden" name="action" value="save" />
					<input type="hidden" name="id" value="<?php echo $g->id ?>" />
					<input type="hidden" name="nonce" value="<?php echo $_POST['nonce']; ?>" />
				</div>
			</form>
			
			<script type="text/javascript">
				(function($){
					$("#edit-gig-<?php echo $g->id ?> .date").calendar({dateFormat:"YMD-"});
					setupPerformances();
					
					$("#edit-gig-reset-<?php echo $g->id ?>").click(function(){
						$(this).parents("tr.panel").hide();
					});
					
					$("#edit-gig-<?php echo $g->id ?>").ajaxForm({
						dataType: "json",
						success:function(json){
							row = $("#gig-panel-" + json.gig.id).hide().prev();
							row.children("td.eventName").html(json.gig.eventName);
							row.children("td.date").html(json.gig.date);
							row.find("a.guid").attr("href", json.gig.permalink);
							times = row.children("td.time");
							times.html("");
							for ( i = 0; i < json.gig.performances.length; i++ ) {
								time = json.gig.performances[i].time.split(":");
								if ( time[0] == 0 ) {
									time[0] = 12;
									time[2] = 'am';
								} else if ( time[0] == 12 ) {
									time[2] = 'pm';
								} else if ( time[0] < 12 ) {
									time[2] = 'am';
								} else if ( time[0] > 12 ) {
									time[0] = time[0] - 12;
									time[2] = 'pm';
								}
								times.append('<span class="time">' + time[0] + ':' + time[1] + time[2] + '</span> ');
							}
							
						}
					});
				}(jQuery));
			</script>
		<?php
		break;
		
	case 'save':
		$g = new gig($_POST['id']);

		$g->date = $_POST['date'];
		$g->notes = $_POST['notes'];
		$g->eventName = $_POST['eventName'];
		
		if ( isset($_POST['performanceID']) ) {
			foreach ( $_POST['performanceID'] as $key => $pid ) {
				$p = new performance((empty($pid) ? null : $pid));
				$p->gigID = $g->id;
				$p->link = $_POST['link'][$key];
				$p->shortNotes = $_POST['shortNotes'][$key];
				$p->ages = (empty($_POST['ages-custom'][$key]) ? $_POST['ages'][$key] : $_POST['ages-custom'][$key]);
				$p->time = date("H:i:s", strtotime($_POST['hour'][$key] . ':' . $_POST['minute'][$key] . ' ' . $_POST['meridiem'][$key]));
				$p->save();
			}
		}
		
		$p = new performance();
		if ( isset($_POST['delete']) ) {
			foreach ( $_POST['delete'] as $pid ) {
				$p->get($pid);
				$p->delete();
			}
		}
		
		$g->save();
		echo '{success:true, gig:' . $g->toJSON() . '}';
		break;
		
	case 'performance-form':
		if ( isset($_POST['id']) ) {
			pForm($_POST['id'], false);
		} else {
			pForm((int) $_POST['count'], true);
		}
		break;
}


function pForm($id, $new = true, $remove = true) {
	global $folder;
	$p = new performance();
	if ( $new ) {
		$count = 'c' . $id;
	} else {
		$p->get($id);
		$count = 'id' . $id;
	}
	
	$ages = array(
		"All Ages",
		"21+",
		"16+"
	);
	
	$time = explode(":", $p->time);
	$minutes = $time[1];
	
	if ( $time[0] == 0 ) {
		$hour = "12";
		$meridiem = "AM";
	} elseif ( $time[0] == 12 ) {
		$hour = "12";
		$meridiem = "PM";
	} elseif ( $time[0] < 12 ) {
		$hour = $time[0];
		$meridiem = "AM";
	} else {
		$hour = $time[0] - 12;
		$meridiem = "PM";
	}
	?>
		<table id="performance-<?php echo $count ?>" class="performance performance-<?php echo $count ?> <?php if ( $new ) echo 'new' ?>"><tbody>
			<tr>
				<td>
					<input type="hidden" class="performanceID" name="performanceID[]" value="<?php echo $p->id; ?>" />
					Performance Time:</label>
				</td><td>
					<div>
						<select name="hour[]">
							<?php for ( $i = 1; $i <= 12; $i++ ) : ?>
								<option <?php if ( $i == $hour ) echo 'selected="selected"' ?>><?php echo $i ?></option>
							<?php endfor; ?>
						</select>
						<select name="minute[]">
							<option <?php if ( "00" == $minutes ) echo 'selected="selected"' ?>>00</option>
							<option <?php if ( "15" == $minutes ) echo 'selected="selected"' ?>>15</option>
							<option <?php if ( "30" == $minutes ) echo 'selected="selected"' ?>>30</option>
							<option <?php if ( "45" == $minutes ) echo 'selected="selected"' ?>>45</option>
							<option value="00">--</option>
							<?php for ( $i = 0; $i <= 59; $i++ ) : ?>
								<option <?php if ( !in_array($i, array("00", "15", "30", "45")) && $i == $minutes ) echo 'selected="selected"' ?>><?php echo str_pad($i, 2, STR_PAD_LEFT, '0') ?></option>
							<?php endfor; ?>
						</select>
						<select name="meridiem[]">
							<option <?php if ( 'AM' == $meridiem ) echo 'selected="selected"' ?>>AM</option>
							<option <?php if ( 'PM' == $meridiem ) echo 'selected="selected"' ?>>PM</option>
						</select>
						<?php if ( $remove ) : ?>
							<div class="delete-performance"><img alt="Remove Performance" title="Remove Performance" class="clickable" src="<?php echo $folder; ?>images/delete.png" /></div>
						<?php endif ?>
					</div>
				</td>
			</tr><tr>
				<td>
					<label for="performance-link[]">External Link (for tickets):</label>
				</td><td>
					<input type="text" class="link wide" name="link[]" id="performance-link[]" value="<?php echo $p->link ?>" />
				</td>
			</tr><tr>
				<td>
					<label for="performance-shortNotes-<?php echo $count; ?>">Short Notes:</label>
				</td><td>
					<input type="text" class="shortNotes wide" name="shortNotes[]" id="performance-shortNotes-<?php echo $count; ?>" value="<?php echo $p->shortNotes ?>" />
				</td>
			</tr><tr>
				<td>
					<label for="performance-ages-<?php echo $count; ?>">Ages:</label>
				</td><td>
					<select name="ages[]" id="performance-ages-<?php echo $count; ?>">
						<?php $found = false; foreach ( $ages as $age ) : ?>
							<option <?php if ( $p->ages == $age ) {echo 'selected="selected"'; $found = true;} ?>><?php echo $age ?></option>
						<?php endforeach; ?>
					</select>
					Or...
					<input type="text" class="ages" name="ages-custom[]" id="performance-ages-custom[]" value="<?php if ( !$found ) echo $p->ages; ?>" />
				</td>
			</tr>
		</tbody></table>
		<script type="text/javascript">
		</script>
	<?php
}
?>